Index: gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zlib.h
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zlib.h,v
diff -u -p -a -u -p -r1.1.1.8 zlib.h
--- gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zlib.h	28 Jan 2025 01:04:23 -0000	1.1.1.8
+++ gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zlib.h	29 Mar 2026 16:31:42 -0000
@@ -1888,9 +2007,9 @@ ZEXTERN int ZEXPORT gzgetc_(gzFile file)
      ZEXTERN z_off_t ZEXPORT gzseek64(gzFile, z_off_t, int);
      ZEXTERN z_off_t ZEXPORT gztell64(gzFile);
      ZEXTERN z_off_t ZEXPORT gzoffset64(gzFile);
-     ZEXTERN uLong ZEXPORT adler32_combine64(uLong, uLong, z_off_t);
-     ZEXTERN uLong ZEXPORT crc32_combine64(uLong, uLong, z_off_t);
-     ZEXTERN uLong ZEXPORT crc32_combine_gen64(z_off_t);
+     ZEXTERN uLong ZEXPORT adler32_combine64(uLong, uLong, z_off64_t);
+     ZEXTERN uLong ZEXPORT crc32_combine64(uLong, uLong, z_off64_t);
+     ZEXTERN uLong ZEXPORT crc32_combine_gen64(z_off64_t);
 #  endif
 #else
    ZEXTERN gzFile ZEXPORT gzopen(const char *, const char *);
Index: gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.c
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.c,v
diff -u -p -a -u -p -r1.9 zutil.c
--- gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.c	28 Jan 2025 01:06:11 -0000	1.9
+++ gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.c	29 Mar 2026 16:31:42 -0000
@@ -1,5 +1,5 @@
 /* zutil.c -- target dependent utility functions for the compression library
- * Copyright (C) 1995-2017 Jean-loup Gailly
+ * Copyright (C) 1995-2026 Jean-loup Gailly
  * For conditions of distribution and use, see copyright notice in zlib.h
  */
 
@@ -86,28 +86,36 @@ uLong ZEXPORT zlibCompileFlags(void) {
     flags += 1L << 21;
 #endif
 #if defined(STDC) || defined(Z_HAVE_STDARG_H)
-#  ifdef NO_vsnprintf
-    flags += 1L << 25;
-#    ifdef HAS_vsprintf_void
-    flags += 1L << 26;
-#    endif
-#  else
-#    ifdef HAS_vsnprintf_void
-    flags += 1L << 26;
-#    endif
-#  endif
+#   ifdef NO_vsnprintf
+#       ifdef ZLIB_INSECURE
+            flags += 1L << 25;
+#       else
+            flags += 1L << 27;
+#       endif
+#       ifdef HAS_vsprintf_void
+            flags += 1L << 26;
+#       endif
+#   else
+#       ifdef HAS_vsnprintf_void
+            flags += 1L << 26;
+#       endif
+#   endif
 #else
     flags += 1L << 24;
-#  ifdef NO_snprintf
-    flags += 1L << 25;
-#    ifdef HAS_sprintf_void
-    flags += 1L << 26;
-#    endif
-#  else
-#    ifdef HAS_snprintf_void
-    flags += 1L << 26;
-#    endif
-#  endif
+#   ifdef NO_snprintf
+#       ifdef ZLIB_INSECURE
+            flags += 1L << 25;
+#       else
+            flags += 1L << 27;
+#       endif
+#       ifdef HAS_sprintf_void
+            flags += 1L << 26;
+#       endif
+#   else
+#       ifdef HAS_snprintf_void
+            flags += 1L << 26;
+#       endif
+#   endif
 #endif
     return flags;
 }
@@ -142,28 +150,34 @@ const char * ZEXPORT zError(int err) {
 
 #ifndef HAVE_MEMCPY
 
-void ZLIB_INTERNAL zmemcpy(Bytef* dest, const Bytef* source, uInt len) {
-    if (len == 0) return;
-    do {
-        *dest++ = *source++; /* ??? to be unrolled */
-    } while (--len != 0);
+void ZLIB_INTERNAL zmemcpy(void FAR *dst, const void FAR *src, z_size_t n) {
+    uchf *p = (uchf *)dst;
+    const uchf *q = (const uchf *)src;
+    while (n) {
+        *p++ = *q++;
+        n--;
+    }
 }
 
-int ZLIB_INTERNAL zmemcmp(const Bytef* s1, const Bytef* s2, uInt len) {
-    uInt j;
-
-    for (j = 0; j < len; j++) {
-        if (s1[j] != s2[j]) return 2*(s1[j] > s2[j])-1;
+int ZLIB_INTERNAL zmemcmp(const void FAR *s1, const void FAR *s2, z_size_t n) {
+    const uchf *p = (const uchf *)s1, *q = (const uchf *)s2;
+    while (n) {
+        if (*p++ != *q++)
+            return (int)p[-1] - (int)q[-1];
+        n--;
     }
     return 0;
 }
 
-void ZLIB_INTERNAL zmemzero(Bytef* dest, uInt len) {
+void ZLIB_INTERNAL zmemzero(void FAR *b, z_size_t len) {
+    uchf *p = (uchf *)b;
     if (len == 0) return;
-    do {
-        *dest++ = 0;  /* ??? to be unrolled */
-    } while (--len != 0);
+    while (len) {
+        *p++ = 0;
+        len--;
+    }
 }
+
 #endif
 
 #ifndef Z_SOLO
Index: gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.h
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.h,v
diff -u -p -a -u -p -r1.9 zutil.h
--- gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.h	28 Jan 2025 01:06:11 -0000	1.9
+++ gnu/usr.bin/perl/cpan/Compress-Raw-Zlib/zlib-src/zutil.h	29 Mar 2026 16:31:42 -0000
@@ -1,5 +1,5 @@
 /* zutil.h -- internal interface and configuration of the compression library
- * Copyright (C) 1995-2024 Jean-loup Gailly, Mark Adler
+ * Copyright (C) 1995-2026 Jean-loup Gailly, Mark Adler
  * For conditions of distribution and use, see copyright notice in zlib.h
  */
 
@@ -36,6 +36,10 @@
    define "local" for the non-static meaning of "static", for readability
    (compile with -Dlocal if your debugger can't find static symbols) */
 
+extern const char deflate_copyright[];
+extern const char inflate_copyright[];
+extern const char inflate9_copyright[];
+
 typedef unsigned char  uch;
 typedef uch FAR uchf;
 typedef unsigned short ush;
@@ -48,6 +52,8 @@ typedef unsigned long  ulg;
 #    define Z_U8 unsigned long
 #  elif (ULLONG_MAX == 0xffffffffffffffff)
 #    define Z_U8 unsigned long long
+#  elif (ULONG_LONG_MAX == 0xffffffffffffffff)
+#    define Z_U8 unsigned long long
 #  elif (UINT_MAX == 0xffffffffffffffff)
 #    define Z_U8 unsigned
 #  endif
@@ -63,7 +69,9 @@ extern z_const char * const z_errmsg[10]
 /* To be used only when the state is known to be valid */
 
         /* common constants */
-
+#if MAX_WBITS < 9 || MAX_WBITS > 15
+#  error MAX_WBITS must be in 9..15
+#endif
 #ifndef DEF_WBITS
 #  define DEF_WBITS MAX_WBITS
 #endif
@@ -141,7 +149,7 @@ extern z_const char * const z_errmsg[10]
 #  define OS_CODE  7
 #endif
 
-#ifdef __acorn
+#if defined(__acorn) || defined(__riscos)
 #  define OS_CODE 13
 #endif
 
@@ -168,11 +176,10 @@ extern z_const char * const z_errmsg[10]
 #endif
 
 /* provide prototypes for these when building zlib without LFS */
-#if !defined(_WIN32) && \
-    (!defined(_LARGEFILE64_SOURCE) || _LFS64_LARGEFILE-0 == 0)
-    ZEXTERN uLong ZEXPORT adler32_combine64(uLong, uLong, z_off_t);
-    ZEXTERN uLong ZEXPORT crc32_combine64(uLong, uLong, z_off_t);
-    ZEXTERN uLong ZEXPORT crc32_combine_gen64(z_off_t);
+#ifndef Z_LARGE64
+   ZEXTERN uLong ZEXPORT adler32_combine64(uLong, uLong, z_off64_t);
+   ZEXTERN uLong ZEXPORT crc32_combine64(uLong, uLong, z_off64_t);
+   ZEXTERN uLong ZEXPORT crc32_combine_gen64(z_off64_t);
 #endif
 
         /* common defaults */
@@ -211,9 +218,9 @@ extern z_const char * const z_errmsg[10]
 #    define zmemzero(dest, len) memset(dest, 0, len)
 #  endif
 #else
-   void ZLIB_INTERNAL zmemcpy(Bytef* dest, const Bytef* source, uInt len);
-   int ZLIB_INTERNAL zmemcmp(const Bytef* s1, const Bytef* s2, uInt len);
-   void ZLIB_INTERNAL zmemzero(Bytef* dest, uInt len);
+   void ZLIB_INTERNAL zmemcpy(void FAR *, const void FAR *, z_size_t);
+   int ZLIB_INTERNAL zmemcmp(const void FAR *, const void FAR *, z_size_t);
+   void ZLIB_INTERNAL zmemzero(void FAR *, z_size_t);
 #endif
 
 /* Diagnostic functions */
@@ -250,5 +257,75 @@ extern z_const char * const z_errmsg[10]
 /* Reverse the bytes in a 32-bit value */
 #define ZSWAP32(q) ((((q) >> 24) & 0xff) + (((q) >> 8) & 0xff00) + \
                     (((q) & 0xff00) << 8) + (((q) & 0xff) << 24))
+
+#ifdef Z_ONCE
+/*
+  Create a local z_once() function depending on the availability of atomics.
+ */
+
+/* Check for the availability of atomics. */
+#if defined(__STDC__) && __STDC_VERSION__ >= 201112L && \
+    !defined(__STDC_NO_ATOMICS__)
+
+#include <stdatomic.h>
+typedef struct {
+    atomic_flag begun;
+    atomic_int done;
+} z_once_t;
+#define Z_ONCE_INIT {ATOMIC_FLAG_INIT, 0}
+
+/*
+  Run the provided init() function exactly once, even if multiple threads
+  invoke once() at the same time. The state must be a once_t initialized with
+  Z_ONCE_INIT.
+ */
+local void z_once(z_once_t *state, void (*init)(void)) {
+    if (!atomic_load(&state->done)) {
+        if (atomic_flag_test_and_set(&state->begun))
+            while (!atomic_load(&state->done))
+                ;
+        else {
+            init();
+            atomic_store(&state->done, 1);
+        }
+    }
+}
+
+#else   /* no atomics */
+
+#warning zlib not thread-safe
+
+typedef struct z_once_s {
+    volatile int begun;
+    volatile int done;
+} z_once_t;
+#define Z_ONCE_INIT {0, 0}
+
+/* Test and set. Alas, not atomic, but tries to limit the period of
+   vulnerability. */
+local int test_and_set(int volatile *flag) {
+    int was;
+
+    was = *flag;
+    *flag = 1;
+    return was;
+}
+
+/* Run the provided init() function once. This is not thread-safe. */
+local void z_once(z_once_t *state, void (*init)(void)) {
+    if (!state->done) {
+        if (test_and_set(&state->begun))
+            while (!state->done)
+                ;
+        else {
+            init();
+            state->done = 1;
+        }
+    }
+}
+
+#endif /* ?atomics */
+
+#endif /* Z_ONCE */
 
 #endif /* ZUTIL_H */
Index: gnu/usr.bin/perl/ext/POSIX/POSIX.xs
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/ext/POSIX/POSIX.xs,v
diff -u -p -a -u -p -r1.31 POSIX.xs
--- gnu/usr.bin/perl/ext/POSIX/POSIX.xs	26 Dec 2025 22:14:20 -0000	1.31
+++ gnu/usr.bin/perl/ext/POSIX/POSIX.xs	29 Mar 2026 16:31:44 -0000
@@ -3588,7 +3588,7 @@ difftime(time1, time2)
 #     sv_setpv(TARG, ...) could be used rather than
 #     ST(0) = sv_2mortal(newSVpv(...))
 void
-strftime(fmt, sec, min, hour, mday, mon, year, wday = -1, yday = -1, isdst = 0)
+strftime(fmt, sec, min, hour, mday, mon, year, wday = -1, yday = -1, isdst = -1)
 	SV *		fmt
 	int		sec
 	int		min
@@ -3604,10 +3604,8 @@ strftime(fmt, sec, min, hour, mday, mon,
             PERL_UNUSED_ARG(wday);
             PERL_UNUSED_ARG(yday);
 
-            /* -isdst triggers backwards compatibility mode for non-zero
-             * 'isdst' */
             SV *sv = sv_strftime_ints(fmt, sec, min, hour, mday, mon, year,
-                                           -abs(isdst));
+                                      isdst);
 	    if (sv) {
                 sv = sv_2mortal(sv);
             }
Index: gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pm
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pm,v
diff -u -p -a -u -p -r1.10 POSIX.pm
--- gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pm	26 Dec 2025 22:14:20 -0000	1.10
+++ gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pm	29 Mar 2026 16:31:44 -0000
@@ -4,7 +4,7 @@ use warnings;
 
 our ($AUTOLOAD, %SIGRT);
 
-our $VERSION = '2.23';
+our $VERSION = '2.23_01';
 
 require XSLoader;
 
Index: gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pod
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pod,v
diff -u -p -a -u -p -r1.14 POSIX.pod
--- gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pod	26 Dec 2025 22:14:20 -0000	1.14
+++ gnu/usr.bin/perl/ext/POSIX/lib/POSIX.pod	29 Mar 2026 16:31:44 -0000
@@ -1866,49 +1866,17 @@ Identical to the string form of C<$!>, s
 =item C<strftime>
 
 Convert date and time information to string based on the current
-underlying locale of the program (except for any daylight savings time).
-Returns the string.
+underlying locale of the program.
+Returns the string in a mortalized SV; set to an empty string on error.
 
-Synopsis:
-
-	strftime(fmt, sec, min, hour, mday, mon, year,
-		 wday = -1, yday = -1, isdst = 0)
-
-The month (C<mon>) begins at zero,
-I<e.g.>, January is 0, not 1.  The
-year (C<year>) is given in years since 1900, I<e.g.>, the year 1995 is 95; the
-year 2001 is 101.  Consult your system's C<strftime()> manpage for details
-about these and the other arguments.
+ my $sv = strftime(fmt, sec, min, hour, mday, mon, year,
+                   wday = -1, yday = -1, isdst = -1)
 
 The C<wday> and C<yday> parameters are both ignored.  Their values are
 always determinable from the other parameters.
 
-C<isdst> should be C<1> or C<0>, depending on whether or not daylight
-savings time is in effect for the given time or not.
-
-If you want your code to be portable, your format (C<fmt>) argument
-should use only the conversion specifiers defined by the ANSI C
-standard (C99, to play safe).  These are C<aAbBcdHIjmMpSUwWxXyYZ%>.
-But even then, the B<results> of some of the conversion specifiers are
-non-portable.  For example, the specifiers C<aAbBcpZ> change according
-to the locale settings of the user, and both how to set locales (the
-locale names) and what output to expect are non-standard.
-The specifier C<c> changes according to the timezone settings of the
-user and the timezone computation rules of the operating system.
-The C<Z> specifier is notoriously unportable since the names of
-timezones are non-standard. Sticking to the numeric specifiers is the
-safest route.
-
-The arguments, except for C<isdst>, are made consistent as though by
-calling C<mktime()> before calling your system's C<strftime()> function.
-To get correct results, you must set C<isdst> to be the proper value.
-When omitted, the function assumes daylight savings is not in effect.
-
-The string for Tuesday, December 12, 1995 in the C<C> locale.
-
-	$str = POSIX::strftime( "%A, %B %d, %Y",
-				 0, 0, 0, 12, 11, 95, 2 );
-	print "$str\n";
+More details on the behavior and the specification of the other
+parameters are described in L<perlapi/sv_strftime_ints>.
 
 =item C<strlen>
 
Index: gnu/usr.bin/perl/ext/POSIX/t/posix.t
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/ext/POSIX/t/posix.t,v
diff -u -p -a -u -p -r1.13 posix.t
--- gnu/usr.bin/perl/ext/POSIX/t/posix.t	26 Dec 2025 22:14:20 -0000	1.13
+++ gnu/usr.bin/perl/ext/POSIX/t/posix.t	29 Mar 2026 16:31:44 -0000
@@ -273,7 +273,12 @@ print POSIX::strftime("ok $test # %H:%M,
 # input fields to strftime().
 sub try_strftime {
     my $expect = shift;
-    my $got = POSIX::strftime("%a %b %d %H:%M:%S %Y %j", @_);
+    my @input = @_;
+
+    # Add zeros to missing parameters.  The final 0 is for isdst, and the zero
+    # forces use of mini_mktime (unless the code changes).
+    push @input, 0 while @input < 9;
+    my $got = POSIX::strftime("%a %b %d %H:%M:%S %Y %j", @input);
     is($got, $expect, "validating mini_mktime() and strftime(): $expect");
 }
 
Index: gnu/usr.bin/perl/ext/POSIX/t/time.t
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/ext/POSIX/t/time.t,v
diff -u -p -a -u -p -r1.7 time.t
--- gnu/usr.bin/perl/ext/POSIX/t/time.t	26 Dec 2025 22:14:20 -0000	1.7
+++ gnu/usr.bin/perl/ext/POSIX/t/time.t	29 Mar 2026 16:31:44 -0000
@@ -16,14 +16,16 @@ use Test::More tests => 31;
 # Those with a working tzset() should be able to use the TZ below.
 $ENV{TZ} = "EST5EDT";
 
+# It looks like POSIX.xs claims that only VMS and Mac OS traditional
+# don't have tzset().  MingW doesn't work.  Cygwin works in some places, but
+# not others.  The other Win32's below are guesses.
+my $has_tzset = $^O ne "VMS" && $^O ne "cygwin"
+             && ($^O ne "MSWin32" || (   $^O eq "MSWin32"
+                                      && $Config{make} eq 'nmake'))
+             && $^O ne "interix";
+
 SKIP: {
-    # It looks like POSIX.xs claims that only VMS and Mac OS traditional
-    # don't have tzset().  Win32 works to call the function, but it doesn't
-    # actually do anything.  Cygwin works in some places, but not others.  The
-    # other Win32's below are guesses.
-    skip "No tzset()", 1
-       if $^O eq "VMS" || $^O eq "cygwin" ||
-          $^O eq "MSWin32" || $^O eq "interix";
+    skip "No tzset()", 1 unless $has_tzset;
     tzset();
     SKIP: {
         my @tzname = tzname();
@@ -42,9 +44,7 @@ SKIP: {
 $ENV{TZ} = "UTC0UTC";
 
 SKIP: {
-    skip "No tzset()", 2
-       if $^O eq "VMS" || $^O eq "cygwin" ||
-          $^O eq "MSWin32" || $^O eq "interix";
+    skip "No tzset()", 2 unless $has_tzset;
     tzset();
     my @tzname = tzname();
     like($tzname[0], qr/(GMT|UTC)/i, "tzset() to GMT/UTC");
Index: gnu/usr.bin/perl/hints/aix.sh
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/hints/aix.sh,v
diff -u -p -a -u -p -r1.20 aix.sh
--- gnu/usr.bin/perl/hints/aix.sh	28 Jan 2025 01:06:15 -0000	1.20
+++ gnu/usr.bin/perl/hints/aix.sh	29 Mar 2026 16:31:44 -0000
@@ -700,4 +700,7 @@ case "$osvers" in
     ;;
 esac
 
+# GH #23825
+d_duplocale='undef'
+
 # EOF
Index: gnu/usr.bin/perl/hints/catamount.sh
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/hints/catamount.sh,v
diff -u -p -a -u -p -r1.17 catamount.sh
--- gnu/usr.bin/perl/hints/catamount.sh	26 Dec 2025 22:14:20 -0000	1.17
+++ gnu/usr.bin/perl/hints/catamount.sh	29 Mar 2026 16:31:44 -0000
@@ -31,11 +31,11 @@
 # mkdir -p /opt/perl-catamount
 # mkdir -p /opt/perl-catamount/include
 # mkdir -p /opt/perl-catamount/lib
-# mkdir -p /opt/perl-catamount/lib/perl5/5.42.0
+# mkdir -p /opt/perl-catamount/lib/perl5/5.42.2
 # mkdir -p /opt/perl-catamount/bin
 # cp *.h /opt/perl-catamount/include
 # cp libperl.a /opt/perl-catamount/lib
-# cp -pr lib/* /opt/perl-catamount/lib/perl5/5.42.0
+# cp -pr lib/* /opt/perl-catamount/lib/perl5/5.42.2
 # cp miniperl perl run.sh cc.sh /opt/perl-catamount/lib
 #
 # With the headers and the libperl.a you can embed Perl to your Catamount
Index: gnu/usr.bin/perl/lib/B/Op_private.pm
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/lib/B/Op_private.pm,v
diff -u -p -a -u -p -r1.15 Op_private.pm
--- gnu/usr.bin/perl/lib/B/Op_private.pm	26 Dec 2025 22:14:20 -0000	1.15
+++ gnu/usr.bin/perl/lib/B/Op_private.pm	29 Mar 2026 16:31:44 -0000
@@ -118,7 +118,7 @@ package B::Op_private;
 our %bits;
 
 
-our $VERSION = "5.042000";
+our $VERSION = "5.042002";
 
 $bits{$_}{3} = 'OPpENTERSUB_AMPER' for qw(entersub rv2cv);
 $bits{$_}{6} = 'OPpENTERSUB_DB' for qw(entersub rv2cv);
Index: gnu/usr.bin/perl/lib/source/source_encoding.t
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/lib/source/source_encoding.t,v
diff -u -p -a -u -p -r1.1.1.1 source_encoding.t
--- gnu/usr.bin/perl/lib/source/source_encoding.t	26 Dec 2025 22:12:45 -0000	1.1.1.1
+++ gnu/usr.bin/perl/lib/source/source_encoding.t	29 Mar 2026 16:31:44 -0000
@@ -44,8 +44,13 @@ if (fresh_perl_like(<<~'EOT',
                     EOT
                 "",
                 { }, "source encoding can be turned off");
+    fresh_perl_like(<<~'EOT',
+                 use v5.41.0; my $var = "¶";
+                 EOT
+                qr/Use of non-ASCII character 0x[[:xdigit:]]{2} illegal/,
+                { }, ">= 'use statement affects rest of current line'");
 }
-else { # Above test depends on the previous one; if that failed, use this
+else { # Above tests depend on the previous one; if that failed, use this
        # alternate one
     fresh_perl_is(<<~'EOT',
                     use source::encoding 'ascii';
Index: gnu/usr.bin/perl/plan9/config_sh.sample
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/plan9/config_sh.sample,v
diff -u -p -a -u -p -r1.20 config_sh.sample
--- gnu/usr.bin/perl/plan9/config_sh.sample	26 Dec 2025 22:14:21 -0000	1.20
+++ gnu/usr.bin/perl/plan9/config_sh.sample	29 Mar 2026 16:31:45 -0000
@@ -35,8 +35,8 @@ api_subversion='0'
 api_version='42'
 api_versionstring='5.42.0'
 ar='ar'
-archlib='/sys/lib/perl5/5.42.0/386'
-archlibexp='/sys/lib/perl5/5.42.0/386'
+archlib='/sys/lib/perl5/5.42.2/386'
+archlibexp='/sys/lib/perl5/5.42.2/386'
 archname64=''
 archname='386'
 archobjs=''
@@ -833,17 +833,17 @@ inc_version_list=' '
 inc_version_list_init='0'
 incpath=''
 inews=''
-installarchlib='/sys/lib/perl/5.42.0/386'
+installarchlib='/sys/lib/perl/5.42.2/386'
 installbin='/usr/bin'
 installman1dir='/sys/man/1pub'
 installman3dir='/sys/man/2pub'
 installprefix='/usr'
 installprefixexp='/usr'
-installprivlib='/sys/lib/perl/5.42.0'
+installprivlib='/sys/lib/perl/5.42.2'
 installscript='/usr/bin'
-installsitearch='/sys/lib/perl/5.42.0/site_perl/386'
+installsitearch='/sys/lib/perl/5.42.2/site_perl/386'
 installsitebin='/usr/bin'
-installsitelib='/sys/lib/perl/5.42.0/site_perl'
+installsitelib='/sys/lib/perl/5.42.2/site_perl'
 installstyle='lib/perl5'
 installusrbinperl='undef'
 installvendorarch=''
@@ -971,8 +971,8 @@ pmake=''
 pr=''
 prefix='/usr'
 prefixexp='/usr'
-privlib='/sys/lib/perl/5.42.0'
-privlibexp='/sys/lib/perl/5.42.0'
+privlib='/sys/lib/perl/5.42.2'
+privlibexp='/sys/lib/perl/5.42.2'
 procselfexe=''
 prototype='define'
 ptrsize='4'
@@ -1037,13 +1037,13 @@ sig_num='0 1 2 3 4 5 6 7 8 9 10 11 12 13
 sig_num_init='0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 0'
 sig_size='50'
 signal_t='void'
-sitearch='/sys/lib/perl/5.42.0/site_perl/386'
+sitearch='/sys/lib/perl/5.42.2/site_perl/386'
 sitearchexp='/sys/lib/perl/site_perl/386'
 sitebin='/usr/bin'
 sitebinexp='/usr/bin'
-sitelib='/sys/lib/perl/5.42.0/site_perl'
-sitelib_stem='/sys/lib/perl/5.42.0/site_perl'
-sitelibexp='/sys/lib/perl/5.42.0/site_perl'
+sitelib='/sys/lib/perl/5.42.2/site_perl'
+sitelib_stem='/sys/lib/perl/5.42.2/site_perl'
+sitelibexp='/sys/lib/perl/5.42.2/site_perl'
 siteprefix='/usr'
 siteprefixexp='/usr'
 sizesize='4'
@@ -1078,7 +1078,7 @@ stdio_stream_array=''
 strerror_r_proto='0'
 strings='/sys/include/ape/string.h'
 submit=''
-subversion='0'
+subversion='2'
 sysman='/sys/man/1pub'
 tail=''
 tar=''
@@ -1163,8 +1163,8 @@ vendorlib_stem=''
 vendorlibexp=''
 vendorprefix=''
 vendorprefixexp=''
-version='5.42.0'
-version_patchlevel_string='version 42 subversion 0'
+version='5.42.2'
+version_patchlevel_string='version 42 subversion 2'
 versiononly='undef'
 vi=''
 xlibpth=''
@@ -1179,7 +1179,7 @@ config_args=''
 config_argc=0
 PERL_REVISION=5
 PERL_VERSION=42
-PERL_SUBVERSION=0
+PERL_SUBVERSION=2
 PERL_API_REVISION=5
 PERL_API_VERSION=42
 PERL_API_SUBVERSION=0
Index: gnu/usr.bin/perl/pod/perl.pod
===================================================================
RCS file: /home/afresh1/OpenBSD-perl/OP/cvs/src/gnu/usr.bin/perl/pod/perl.pod,v
diff -u -p -a -u -p -r1.46 perl.pod
--- gnu/usr.bin/perl/pod/perl.pod	26 Dec 2025 22:16:26 -0000	1.46
+++ gnu/usr.bin/perl/pod/perl.pod	29 Mar 2026 16:31:45 -0000
@@ -181,10 +181,13 @@ aux h2ph h2xs perlbug pl2pm pod2html pod
 
     perlhist            Perl history records
     perldelta           Perl changes since previous version
+    perl5421delta       Perl changes in version 5.42.1
     perl5420delta       Perl changes in version 5.42.0
+    perl5403delta       Perl changes in version 5.40.3
     perl5402delta       Perl changes in version 5.40.2
     perl5401delta       Perl changes in version 5.40.1
     perl5400delta       Perl changes in version 5.40.0
+    perl5385delta       Perl changes in version 5.38.5
     perl5384delta       Perl changes in version 5.38.4
     perl5383delta       Perl changes in version 5.38.3
     perl5382delta       Perl changes in version 5.38.2
Index: gnu/usr.bin/perl/pod/perl5385delta.pod
===================================================================
RCS file: gnu/usr.bin/perl/pod/perl5385delta.pod
diff -N gnu/usr.bin/perl/pod/perl5385delta.pod
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ gnu/usr.bin/perl/pod/perl5385delta.pod	29 Mar 2026 16:31:45 -0000
@@ -0,0 +1,125 @@
+=encoding utf8
+
+=head1 NAME
+
+perl5385delta - what is new for perl v5.38.5
+
+=head1 DESCRIPTION
+
+This document describes differences between the 5.38.4 release and the 5.38.5
+release.
+
+If you are upgrading from an earlier release such as 5.38.3, first read
+L<perl5384delta>, which describes differences between 5.38.3 and 5.38.4.
+
+=head1 Security
+
+=head2 [CVE-2025-40909] Perl threads have a working directory race condition where file operations may target unintended paths
+
+Perl thread cloning had a working directory race condition where file
+operations may target unintended paths.  Perl 5.38 will no longer chdir to each
+handle.
+
+This problem was discovered by Vincent Lefèvre via
+[L<GH #23010|https://github.com/Perl/perl5/issues/23010>] and assigned
+[L<CVE-2025-40909|https://lists.security.metacpan.org/cve-announce/msg/30017499/>]
+by the L<CPAN Security Group|https://security.metacpan.org/>.
+
+Fixes were provided via [L<GH #23019|https://github.com/Perl/perl5/pull/23019>]
+and [L<GH #23361|https://github.com/Perl/perl5/pull/23361>].
+
+=head1 Incompatible Changes
+
+There are no changes intentionally incompatible with 5.38.4.  If any exist,
+they are bugs, and we request that you submit a report.  See L</Reporting
+Bugs> below.
+
+=head1 Modules and Pragmata
+
+=head2 Updated Modules and Pragmata
+
+=over 4
+
+=item *
+
+L<Module::CoreList> has been upgraded from version 5.20250413_38 to 5.20250803_38.
+
+=back
+
+=head1 Documentation
+
+=head2 Changes to Existing Documentation
+
+We have attempted to update the documentation to reflect the changes listed in
+this document.  If you find any we have missed, open an issue at
+L<https://github.com/Perl/perl5/issues>.
+
+=head1 Testing
+
+Tests were added and changed to reflect the other additions and changes in this
+release.
+
+=head1 Acknowledgements
+
+Perl 5.38.5 represents approximately 4 months of development since Perl 5.38.4
+and contains approximately 3,300 lines of changes across 46 files from 8
+authors.
+
+Excluding auto-generated files, documentation and release tools, there were
+approximately 1,100 lines of changes to 7 .pm, .t, .c and .h files.
+
+Perl continues to flourish into its fourth decade thanks to a vibrant community
+of users and developers.  The following people are known to have contributed
+the improvements that became Perl 5.38.5:
+
+James E Keenan, Karen Etheridge, Leon Timmermans, Lukas Mai, Philippe Bruhat
+(BooK), Richard Leach, Steve Hay, Thibault Duponchelle.
+
+The list above is almost certainly incomplete as it is automatically generated
+from version control history.  In particular, it does not include the names of
+the (very much appreciated) contributors who reported issues to the Perl bug
+tracker.
+
+Many of the changes included in this version originated in the CPAN modules
+included in Perl's core.  We're grateful to the entire CPAN community for
+helping Perl to flourish.
+
+For a more complete list of all of Perl's historical contributors, please see
+the F<AUTHORS> file in the Perl source distribution.
+
+=head1 Reporting Bugs
+
+If you find what you think is a bug, you might check the perl bug database at
+L<https://github.com/Perl/perl5/issues>.  There may also be information at
+L<http://www.perl.org/>, the Perl Home Page.
+
+If you believe you have an unreported bug, please open an issue at
+L<https://github.com/Perl/perl5/issues>.  Be sure to trim your bug down to a
+tiny but sufficient test case.
+
+If the bug you are reporting has security implications which make it
+inappropriate to send to a public issue tracker, then see
+L<perlsec/SECURITY VULNERABILITY CONTACT INFORMATION> for details of how to
+report the issue.
+
+=head1 Give Thanks
+
+If you wish to thank the Perl 5 Porters for the work we had done in Perl 5, you
+can do so by running the C<perlthanks> program:
+
+    perlthanks
+
+This will send an email to the Perl 5 Porters list with your show of thanks.
+
+=head1 SEE ALSO
+
+The F<Changes> file for an explanation of how to view exhaustive details on
+what changed.
+
+The F<INSTALL> file for how to build Perl.
+
+The F<README> file for general stuff.
+
+The F<Artistic> and F<Copying> files for copyright information.
+
+=cut
